## 6.9  2017-4-7

- ​性能优化
	- 优化内存，临时对象创建太多，导致低端机上频繁GC，造成系统不稳定。  
		- 原来JNI通过创建对象返回值给Java，现改为JNI回调JNIWrapper类中的方法，把值设置回去，减少对象创建。  
		- LocationResult根据不同场景拆分出不同的对象，去掉额外成员变量，减少内存开销，去掉不用的接口。增加NetworkLocationResult和BuildingLocationResult
		- 在线定位返回多个定位结果，现在算法不会有多个结果，去掉冗余的一些List变量。
		- 修改部分算法JNI接口：JNI传int类型楼层、
		- foreach使用for替换避免临时对象创建iterator
	- 减少包数量，删除了Utils包，合并到pdr里面
	- 减少常驻内存大小：围栏范围缩小到10km，围栏经纬度使用float保存。
	- IOD的JNI接口去掉setGPS位置接口，不设置具体GPS位置，算法用不到具体位置。
	- 去掉jniGetMag8Result等IOD和定位SDK都不需要的接口以及消息，减少没必要的内存耗费
- 明文IMEI的bug
	- 以静态库的方式集成amap的url加密算法：避免AOS请求的URL中暴露明文IMEI
	- 围栏数据下载请求压缩：避免请求体中包含明文的imei。
- LBS
	- SHA1错误的时候提示MessageCode.MSG_LBS_OK修改成MessageCode.MSG_LBS_ERROR，需要更新网站上LBS文档
	- 更新LBS的scode算法：csid放到header里面而不是url中
- 目前pdr定位结果直接返回引用，多线程下会存在数据错乱。修改成拷贝结果，并使用synchronized同步
- 地下场馆楼层错误：在芳草地地下做蓝牙测试的时候，-1层没有定位结果，其他负数楼层会有楼层错误
- 新功能
	- 在线定位增加失败逻辑：网络定位10S之内没有新的更新，就停止向客户提供结果。
	- IOD中粗定位逻辑调整，启动粗定位之后，同时启动WIFI和BLE定位，避免只有蓝牙定位，没有WIFI定位不能进入室内的潜在bug，此修改增加了蓝牙扫描，产品性能上会略有提升。
	- 优化配置类接口，增加setAOSParam接口，接受jobj，方便室外定位组集成。同时修复LBS下抛出json obj异常日志的bug
	- 所有请求协议从http->https
- 影响范围：此次版本更新修改内容较多，尤其是性能优化部分，对代码整体结构有较大调整，本次测试需要全面、深入进行多次回归测试，重点：
	- 各模块稳定性是否有崩溃
	- 各请求URL和post体是否包含明文
	- pdr步数是否正常


## SDK说明

### SDK包介绍
1. indoorpdr-x.x.(jar&so): 通过传感器数据计算出出用户的步数和方向。同时封装了WIFI扫描、BLE扫描、地磁扫描等接口。
2. onlinelocation-x.x.(jar&so): 室内在线定位模块，依赖上面1中的indoorpdr。
3. indooroutdoordetector-x.x.(jar&so): 室内外判断模块，依赖上面1中的indoorpdr。

### Demo
1. indoorlocationdemo-release.apk:　集成图形化的PDR测试、室内在线定位测试、室内离线定位测试等。使用方法：
	1. 打印logcat日志：需要在手机/sdcard/autonavi/indoor目录下创建logcat文件
	2. 保存文件日志：需要在手机/sdcard/autonavi/indoor目录下创建logcat文件夹
	3. 算法文件日志：需要在手机/sdcard/autonavi/indoor目录下创建logalgo文件夹
	4. 模拟定位：拷贝现场定位定位的算法日志到/sdcard/autonavi/indoor/demo下，并在demo中进行配置即可
	5. 注：以上修改都需要重启demo才能生效，FLP手机上需要重启手机。
2. IODDemo-release.apk:室内外测试demo
3. LocationPerformanceTest-debug.apk:室内在线定位性能测试模块，界面上不做任何输出，避免干扰测试准确性。使用时也需要清空/sdcard/autonavi/indoor目录
4. IODPerformanceTest-debug.apk:室内外切换性能测试。条件如3


### SDK 集成

下表说明了室内定位各模块在公司各平台的集成说明，表格中Y表示此模块需要在某平台上集成：

| 模块                 | AMap |FLP| 开放平台 |
|---------------------|------|---|----------|
|indoorpdr            | Y    | Y | Y        |
|onlinelocation       | Y    | Y | Y        |
|indooroutdoordetector| Y    | Y | N        |

